#include "main.h"

extern struct object objects[64];
extern struct object ship;

extern SDL_Surface *screen;

extern int size,
    score,
    ships,
    cannon_ammo,
    missiles,
    is_boss,
    current_level,
    game_finished,
    godmode,
    godtime;

extern Mix_Chunk *chunk[NUM_CHUNKS];

void CheckScreenEdges(int index)
{
    if(objects[index].type == ENEMY		||
	    objects[index].type == BULLET	||
	    objects[index].type == MISSILE	||
	    objects[index].type == PACK_LIVE	||
	    objects[index].type == PACK_SHIELD	||
	    objects[index].type == PACK_ENERGY	||
	    objects[index].type == PACK_SURPRISE){

	if(objects[index].rect.y > screen->h)
	    objects[index].remove =1;
	else {
	    if(objects[index].rect.x < 0-objects[index].image->w)
		objects[index].direction = 1;
	    else if(objects[index].rect.x > screen->w)
		objects[index].direction = 0;
	}
    }	
    else if(objects[index].type == SHIP_BULLET || objects[index].type == SHIP_MISSILE){
	if(objects[index].rect.y <= 10){
	    objects[index].remove=1;
	}
    }
}

int Collide(struct object *obj_a, struct object *obj_b)
{
    if(obj_a->rect.x + obj_a->image->w < obj_b->rect.x ||
	    obj_a->rect.x > obj_b->rect.x + obj_b->image->w ||
	    obj_a->rect.y > obj_b->rect.y + obj_b->image->h ||
	    obj_a->rect.y + obj_a->image->h < obj_b->rect.y)
	return 0;

    return 1;
}

void CheckEnemyCollisions(int index)
{
    int j;

    for(j=index+1;j<size;j++)
    {
	if(objects[index].type == objects[j].type	|| (
		    objects[index].type == BULLET	||
		    objects[index].type == MISSILE	||
		    objects[j].type	== BULLET	||
		    objects[j].type	== MISSILE	||
		    (objects[index].type>=PACK_LIVE && objects[index].type<=PACK_SURPRISE) ||
		    (objects[j].type>=PACK_LIVE && objects[j].type<=PACK_SURPRISE)))
	    continue;

	if(Collide(&objects[index],&objects[j])) //sprawdzenie kolizji pociskow playera z wrogiem/jego pociskami
	{
	    if((objects[j].type == BOSS && objects[index].type == ENEMY) ||
		    (objects[j].type == ENEMY && objects[index].type == BOSS))
		return;
	    // Po wykryciu kolizji odejmowana jest energia
	    // Wrogowie nie posiadaj pancerza
	    objects[index].energy -= objects[j].type == SHIP_BULLET ? 34 : 70;

	    if(objects[index].energy <= 0){
		if(objects[index].type == ENEMY ) {
		    score+=rand_ab(70,200);
		} else if(objects[index].type == BOSS ) {
		    score+=rand_ab(3000,4500);
		    is_boss = 0;
		    AddMessage("Level %d completed",current_level);
		    if(current_level == NUM_LEVELS)
			game_finished = 1;
		    current_level++;
		    if(current_level > NUM_LEVELS)
			current_level = NUM_LEVELS;
		}
		objects[index].energy = 0;
	    }

	    objects[j].energy -= 20;
	    if(objects[j].energy <= 0) {
		objects[j].energy = 0;
	    }
	    return;
	}
    }
}

void CheckShipCollisions()
{
    int j;
    if(SDL_GetTicks() - godtime > 3000 && godmode)
	godmode = 0;

    for(j=0; j<size; j++)
    {
	if(ships != 0)
	    if(Collide(&ship,&objects[j]))
	    {
		if((objects[j].type == ENEMY || objects[j].type == BOSS || objects[j].type == BULLET || objects[j].type == MISSILE) && !godmode) {
		    ship.shield -= (objects[j].type == ENEMY || objects[j].type == BOSS) ? 50 : (objects[j].type == BULLET ? 2 : 8);

		    if(objects[j].type == ENEMY)
			AddMessage("Look out!");

		    if(ship.shield < 0){
			ship.energy += ship.shield; 
			ship.shield = 0;
		    }
		    if(ship.energy <= 0){
			godtime = SDL_GetTicks();
			godmode = 1;
			ship.energy = 0;
			ships--;
			AddMessage("You lost one ship");
			AddExplosion(ship.rect.x + ship.image->w/2, ship.rect.y + ship.image->h/2);
		    }

		    objects[j].energy -= (objects[j].type == ENEMY || objects[j].type == BOSS) ? 100 : 20;
		    if(objects[j].energy < 0){
			objects[j].energy = 0;
			if(objects[j].type == BOSS) {
			    is_boss = 0;
			    AddMessage("Level %d completed",current_level);
			    if(current_level == NUM_LEVELS)
				game_finished = 1;

			    current_level++;
			    if(current_level > NUM_LEVELS)
				current_level = NUM_LEVELS;
			}
		    }
		}else
		    if(objects[j].type == PACK_LIVE) {
			ships++;
			objects[j].energy = 0;
			AddMessage("Ship");
		    }else
			if(objects[j].type == PACK_ENERGY) {
			    ship.energy+=70;
			    if(ship.energy > 100)
				ship.energy = 100;
			    objects[j].energy = 0;
			    AddMessage("Energy");
			}else
			    if(objects[j].type == PACK_SHIELD) {
				ship.shield+=70;
				if(ship.shield > 100)
				    ship.shield = 100;
				objects[j].energy = 0;
				AddMessage("Shield");
			    }else
				if(objects[j].type == PACK_SURPRISE) {
				    switch(rand_ab(1,4))
				    {
					case 1:
					    ships++;
					    AddMessage("Ship");
					    break;
					case 2:
					    ship.energy += rand_ab(30,60);
					    if(ship.energy > 100)
						ship.energy = 100;
					    AddMessage("Energy");
					    break;
					case 3:
					    ship.shield += rand_ab(30,60);
					    if(ship.shield > 100)
						ship.shield = 100;
					    AddMessage("Shield");
					    break;
					default:
					    switch(rand_ab(0,1))
					    {
						case 0:
						    missiles+=rand_ab(20,60);
						    AddMessage("Rockets");
						    break;
						default:
						    cannon_ammo+=rand_ab(100,300);
						    AddMessage("Bullets");
						    break;
					    }
					    break;
				    }
				    objects[j].energy = 0;
				}
			    return;
	    }
    }
}

