#pragma comment(lib, "libSDLx.lib")
#pragma comment(lib, "SDL_Image.lib")



#include "main.h"
#include "Bfont.h"
#include "xtl.h"
#include "d3d8.h"

#define Wklej SDL_LowerBlit

//gamepad stuff
SDL_Joystick *GAMEPAD; //Gamepad
Sint16 joyx, joyy; //axes
Sint16 blackbutton;
Sint16 abutton; //A button
Sint16 bbutton;
Sint16 xbutton;
Sint16 ybutton;
Sint16 backbutton; //BACK button
Sint16 startbutton; //START button
Sint16 rstick; 
Sint16 dpad; //dpad
Sint16 ltrigger, rtrigger; //Trigger buttons

LAUNCH_DATA LaunchData = { LDT_TITLE };


int flickerlevel;
	int xpos;
	int ypos;
	int xstretch;
	int ystretch;

	FILE *conf;





char *red[2] = {"\x1b[5;31m","\x1b[0;37m"};
char *green[2] = {"\x1b[1;32m","\x1b[0;37m"};

int size = 0, //number of objects in table 'objects'
    num_explos = 0, //number of explosions in table 'explosions'
    t1, //time 1
    t2, //time 2
    dt, //delta time
    ships = 5, // number of lives
    cannon_ammo = 1200, //number of bullets
    missiles = 50, // number of missiles
    score = 0, // score
    BGPos = 256,
    current_level = 1,
    num_scrolls = 0,
    is_boss = 0,
    message_time,
    game_finished = 0,
    credits = 0,
    credits_pos,
    help = 0,
    godmode = 0,
    godtime,
    //keys in playlist
    //z - previous x - play c - pause v - stop b - next r - repeat
    quit = 0,           // end?
    current_music = 0,  // current music
    z_press,            // is z pressed
    x_press,            // is x pressed
    c_press,            // is c pressed
    v_press,            // is v pressed
    b_press,            // is b pressed
    r_press,            // is r pressed
    p_press,		// is p pressed
    f2_press,		// is F2 pressed
    f3_press,		// is F3 pressed
    space_press,        // change weapon
    paused_music = 0,   // paused music?
    paused_game = 0,    // paused game?
    repeat_music = 0,   // repeat music
    music_volume = 80,  // music volume
    chunk_volume = 70, // chunk volume
    num_frames = 0;

float fps,fps_time;

struct object objects[64];
struct explosion explosions[24];
struct object ship; // player ship

//tracks
char *tracks[] = { "Phenomena Enigma by Mantronix", sounds_dir"mod.phenomena enigma.mod",
    "Lotus 3 - Shamrip", sounds_dir"shamrip.mod",
    "Dragonsfunk by Moby", sounds_dir"mod.dragonsfunk.mod",
    "Knulla-kuk by Moby", sounds_dir"mod.knulla-kuk.mod",
    "10 Minutes Trash", sounds_dir"mod.10minutetrash.mod",
    "Lotus 3 - Miami Ice", sounds_dir"miamiice.mod",
    "Atmosphere", sounds_dir"mod.atmosphere.mod" };

char message[64];

char *images[NUM_IMAGES] = {
    pixmaps_dir"bullet.png",
    pixmaps_dir"missile.png",
    pixmaps_dir"enemy.png",
    pixmaps_dir"enemy2.png",
    pixmaps_dir"pack_ship.png",
    pixmaps_dir"pack_shield.png",
    pixmaps_dir"pack_energy.png",
    pixmaps_dir"pack_surprise.png",
    pixmaps_dir"boss.png",
    pixmaps_dir"boss3a.png",
    pixmaps_dir"ship.png",
    pixmaps_dir"live.png",
    pixmaps_dir"enemy_missile.png"};

SDL_Surface *screen; // ekran
SDL_Surface *icon, // ikona w l/g rogu okna
    *bgfull, // powierzchnia wykorzystywana do skrolowania tla
    *bgimage, // cegielka tla
    *energy,  
    *shield;

SDL_Surface *frame[NUM_BOOM_FRAMES]; //explosion frames
SDL_Surface *obj[NUM_IMAGES];

SDL_Rect BGRect,BGSrc; 
SDL_Rect epos,
    esrc,
    spos,
    ssrc; 
BFont_Info *font; //font

Mix_Music *music[NUM_TRACKS]; //tracks
Mix_Chunk *chunk[NUM_CHUNKS]; //chunks

Uint8 *keys;



int main(int argc, char **argv)
{
	//extern "C" LPDIRECT3DDEVICE8 D3D_Device;
    int i,j; //variables for loops
    int tol_add_ship,
    tol_add_pack,
    game_time,
    ttw;

    srand(time(NULL));

    write_log("Starting session");
    if(SDL_Init(SDL_INIT_VIDEO | SDL_INIT_AUDIO | SDL_INIT_JOYSTICK) < 0){
	write_log("*** ERROR *** Unable to initialize SDL: %s",SDL_GetError());
	write_log("Closing session with error\n");
	error_exit("*** ERROR *** Unable to initialize SDL: %s",SDL_GetError());
    }
    //init screen
    if((screen = SDL_SetVideoMode(800, 600, 16, SDL_HWSURFACE | SDL_DOUBLEBUF | SDL_FULLSCREEN )) == NULL){
	write_log("Unable to create SDL screen: %s",SDL_GetError());
	write_log("Closing session with error\n");
	error_exit("Unable to create SDL screen: %s",SDL_GetError());
    }

	//now load our settings
	load_settings();

	//open our Joystick
	GAMEPAD = SDL_JoystickOpen(0); //Open Pad 1
	SDL_JoystickEventState(SDL_ENABLE); //Enable event stuff for our pad

    //open audio
    if (Mix_OpenAudio(44100, AUDIO_S16, 2, 512) < 0) {
	write_log("*** ERROR *** Unable to open audio: %s",SDL_GetError());
	write_log("Closing session with error\n");
	error_exit("*** ERROR *** Unable to open audio: %s",SDL_GetError());
    }

    //load tracks
    for(i=0;i<NUM_TRACKS;i++)
    {	
	music[i] = Mix_LoadMUS(tracks[i*2+1]);
	//check tracks
	if(music[i] == NULL) {
	    write_log("*** ERROR *** Unable to load %s: %s",tracks[i*2+1],SDL_GetError()); 
	    write_log("Closing session with error\n");
	    error_exit("*** ERROR *** Unable to load %s: %s",tracks[i*2+1],SDL_GetError());
	}
    }

    //load SFX
    chunk[0] = Mix_LoadWAV(sounds_dir"shot.wav");
    chunk[1] = Mix_LoadWAV(sounds_dir"shot2.wav");
    chunk[2] = Mix_LoadWAV(sounds_dir"empty.wav");
    chunk[3] = Mix_LoadWAV(sounds_dir"explode.wav");
    //check SFX's
    for(i=0;i<NUM_CHUNKS;i++)
	if(chunk[i] == NULL) {
	    write_log("*** ERROR *** Unable to load WAV: %s",SDL_GetError());
	    write_log("Closing session with error\n");
	    error_exit("*** ERROR *** Unable to load WAV: %s",SDL_GetError());
	}

    //load font
    font = LoadFont(pixmaps_dir"font.png");
    //check font
    if(font == NULL) {
	write_log("*** ERROR *** Unable to load font: %s",SDL_GetError());
	write_log("Closing session with error\n");
	error_exit("*** ERROR *** Unable to load font: %s",SDL_GetError());
    }

    for(i=0;i<NUM_IMAGES;i++){
	obj[i] = LoadImage(images[i]);
	CheckSurface(obj[i],"Unable to load image: %s",SDL_GetError());
    }

    LoadFrames(); //load all explosion frames

    // wczytanie cegielki tworzacej tlo
    bgimage = IMG_Load(pixmaps_dir"bg.png"); 
    CheckSurface(bgimage,"Unable to load background: %s",SDL_GetError());

    bgfull=SDL_CreateRGBSurface(SDL_HWSURFACE,
	    screen->w,
	    bgimage->h * (screen->h/bgimage->h+2),
	    screen->format->BitsPerPixel,
	    screen->format->Rmask, //RED
	    screen->format->Gmask, //GREEN
	    screen->format->Bmask, //BLUE
	    screen->format->Amask);//ALPHA

    for (i=0;i< screen->w/bgimage->w +1;i++)
	/* w pionie wstawienie o jedn cegiek wicej, ni potrzeba do samego zapenienia 
	 * prawd mwic moe si w teorii zdarzy, e wstawione zostan dwe cegieki wicej ;) */
	for (j=0;j< screen->h/bgimage->h +2;j++)
	{
	    BGRect.x=i*bgimage->w;
	    BGRect.y=j*bgimage->h;
	    SDL_BlitSurface(bgimage, NULL, bgfull, &BGRect);
	}	    

    energy = obj[11];
    CheckSurface(energy,"Unable to load image: %s",SDL_GetError());
    shield = obj[11];
    CheckSurface(shield,"Unable to load image: %s",SDL_GetError()); 

    //set position of columns
    spos.x = 0;
    spos.y = screen->h - shield->h - FontHeight(font)*2;
    epos.x = screen->w - shield->w;
    epos.y = screen->h - energy->h - FontHeight(font)*2;

    //make player ship
    //Load ship image
    ship.image = obj[10];
    CheckSurface(ship.image,"Unable to load image: %s",SDL_GetError());
    SetBGAlpha(ship.image); // set color key for background image
    ship.velocity = 0.4; //Set ship velocity
    ship.weapon = CANNON; // set ship weapon
    ship.energy = 100; // ship energy
    ship.shield = 50; // shield
    ship.tols = SDL_GetTicks(); // time of last shot
    ship.rect.x = screen->w/2 - ship.image->w/2; // position in x
    ship.rect.y = screen->h - ship.image->h; // y
    //end
    //ICON
    icon = obj[10]; //load image for icon
    CheckSurface(icon,"Unable to load image: %s",SDL_GetError()); // check surface
    SetBGAlpha(icon); // set background transparent

    //Caption
    SDL_WM_SetCaption("SDL-Fighter by Radoslaw Gniazdowski",""); //set window caption
    SDL_WM_SetIcon(icon,NULL); //set icon
    SDL_ShowCursor(0); // do not show cursor

    t1 = SDL_GetTicks(); // time 1

    AddOBJ(0,0,ENEMY); // add enemy on start

    Mix_PlayMusic(music[current_music],1); //play music
    Mix_VolumeMusic(music_volume); //set music volume

    Mix_HookMusicFinished(NextMUS); // Ustawienie funkcji wywolywanej po zakonczeniu muzyki (nastepny utwor) 
    Mix_Volume(-1,chunk_volume); // set volume for all chunks
    tol_add_ship = t1; 
    tol_add_pack = t1;

    game_time = time(NULL);
    message_time = t1;

    BGSrc.w = screen->w;
    BGSrc.h = screen->h;
    BGSrc.x = 0;
    BGRect.x = 0;
    BGRect.y = 0;   
    BGRect.w = screen->w;
    BGRect.h = screen->h;

    fps_time = ((float)SDL_GetTicks())/1000.0f;
    
    while(!quit)
    {
	// energia 0, sa jeszcze statki -> nowy statek
	if(ship.energy == 0 && ships != 0) {
	    ship.energy = 100;
	    ship.shield = 50;
	    ship.rect.x = screen->w/2 - ship.image->w/2;
	    ship.rect.y = screen->h - ship.image->h;
	    ship.weapon = CANNON;
	    cannon_ammo = 1200;
	    missiles = 50;
	}

	// odczytanie klawiszy
	SDL_PumpEvents();
	keys = SDL_GetKeyState(NULL);
	SDL_JoystickUpdate(); //manual refresh of the gamepad(s)
	//parse all gamepads
	joyx = SDL_JoystickGetAxis(GAMEPAD, 0);
	joyy = SDL_JoystickGetAxis(GAMEPAD, 1);
	dpad = SDL_JoystickGetHat(GAMEPAD, 0);
	blackbutton = SDL_JoystickGetButton(GAMEPAD, 4); //Black Button
	abutton = SDL_JoystickGetButton(GAMEPAD, 0); //Get A-Button(0)
	bbutton = SDL_JoystickGetButton(GAMEPAD, 1);
	backbutton = SDL_JoystickGetButton(GAMEPAD, 9); //Get BACK-Button(9)
	rstick = SDL_JoystickGetButton(GAMEPAD,11);
	ltrigger = SDL_JoystickGetButton(GAMEPAD,6);
	rtrigger = SDL_JoystickGetButton(GAMEPAD,7);
	xbutton = SDL_JoystickGetButton(GAMEPAD,2);
	ybutton = SDL_JoystickGetButton(GAMEPAD,3);
	startbutton = SDL_JoystickGetButton(GAMEPAD,8);
	// pauza
	if(!p_press && !help)
	    if(keys[SDLK_p] || startbutton) {
		SDL_Delay(150);
		paused_game = !paused_game;

		if(paused_game) {
		    if(Mix_Playing(-1))
			Mix_Pause(-1);
		} else {
		    if(Mix_Paused(-1))
			Mix_Resume(-1);
		}
	    }
	p_press = (keys[SDLK_p]&&startbutton);

	t2 = SDL_GetTicks();
	dt = (paused_game ? 0 : t2-t1); // delta time

	if(paused_game) {
	    tol_add_ship+=t2-t1;
	    tol_add_pack+=t2-t1;
	}

	t1 = t2;

	BGPos -= (int)(0.08*dt); //Change position of background
	if(BGPos<0) { 
	    BGPos=256;
	    if(!is_boss && !game_finished)
		num_scrolls++;
	}
	if(num_scrolls == 20) {
	    is_boss = 1;
	    num_scrolls = 0;
	    AddOBJ(0,0,BOSS);
	}
	BGSrc.y = (int)BGPos;
	Wklej(bgfull, &BGSrc, screen, &BGRect);


	if(credits) {
	    credits_pos-=2;
	    if(credits_pos < -(FontHeight(font)*15)-20)
		credits_pos = screen->h;
	}

	//muzyka: poprzedni
	if(!z_press)
	    if(keys[SDLK_z]||ltrigger) {
		SDL_Delay(150);
		Mix_HaltMusic();
		current_music--;
		if(current_music < 0)
		    current_music = NUM_TRACKS - 1;
		Mix_PlayMusic(music[current_music],1);
		Mix_VolumeMusic(music_volume);
	    }
	z_press = (keys[SDLK_z]&&ltrigger);

	//muzyka: play
	if(!x_press)
	    if(keys[SDLK_x]) {
		SDL_Delay(150);
		Mix_HaltMusic();
		Mix_PlayMusic(music[current_music],1);
	    }
	x_press = (keys[SDLK_x]);

	//muzyka: pauza
	if(!c_press)
	    if(keys[SDLK_c]||rstick) {
		SDL_Delay(150);
		paused_music=!paused_music;
		if(paused_music == 1)
		    Mix_PauseMusic();
		else
		    Mix_ResumeMusic();
	    }
	c_press = (keys[SDLK_c]&&rstick);

	//muzyka: stop
	if(!v_press)
	    if(keys[SDLK_v])
		Mix_HaltMusic();
	v_press = (keys[SDLK_v]);

	//muzyka: nastepny
	if(!b_press)
	    if(keys[SDLK_b]||rtrigger) {
		SDL_Delay(150);
		Mix_HaltMusic();
		current_music++;
		if(current_music == NUM_TRACKS)
		    current_music = 0;
		Mix_PlayMusic(music[current_music],1);
		Mix_VolumeMusic(music_volume);
	    }
	b_press = (keys[SDLK_b]&&rtrigger);

	//muzyka: repeat
	if(!r_press)
	    if(keys[SDLK_r])
		repeat_music = !repeat_music;
	r_press = (keys[SDLK_r]);
	//muzyka: KONIEC


	if(keys[SDLK_F1]) 
	    SDL_WM_ToggleFullScreen(screen); // toggle fullscreen

	if(!f2_press && !credits) //Help
	    if(keys[SDLK_F2]||backbutton) {
		SDL_Delay(150);
		help = !help;
		if(help) {
		    paused_game = 1;
		    if(Mix_Playing(-1))
			Mix_Pause(-1);	
		}
		else {
		    paused_game = 0;
		    if(Mix_Paused(-1))
			Mix_Resume(-1);
		}
	    }
	f2_press = (keys[SDLK_F2]&&backbutton);

	if(!f3_press)
	    if(keys[SDLK_F3]||blackbutton) {
		SDL_Delay(150);
		credits = !credits;
		credits_pos = screen->h;
		if(credits) {
		    paused_game = 1;
		    if(Mix_Playing(-1))
			Mix_Pause(-1);
		}
		else {
		    paused_game = 0;
		    if(Mix_Paused(-1))
			Mix_Resume(-1);
		}
	    }

	f3_press = (keys[SDLK_F3]&&blackbutton);

	if(!paused_game) 
	{
	    if(ships != 0)
		if(!space_press)
		    if(keys[SDLK_SPACE]||bbutton) {
			SDL_Delay(150);
			if(ship.weapon == CANNON)
			    ship.weapon = ROCKET;
			else 
			    ship.weapon = CANNON;
		    }
	    space_press = (keys[SDLK_SPACE]&&bbutton);

	    // strzelanie
	    if(ships != 0)
		if(keys[SDLK_LCTRL] || keys[SDLK_RCTRL]||abutton)
		{
		    ttw = (ship.weapon == CANNON ? 90 : 200);

		    if(t2 - ship.tols > ttw) {
			if(ship.weapon == CANNON){
			    if(cannon_ammo > 0){
				AddOBJ(0,0,SHIP_BULLET); //add bullet
				cannon_ammo--;
				Mix_PlayChannel(-1,chunk[0],0); // play shot
			    }else{
				Mix_PlayChannel(-1,chunk[2],0); //empty
			    }
			}else if(ship.weapon == ROCKET){
			    if(missiles > 0)
			    {
				AddOBJ(0,0,SHIP_MISSILE); // add missile
				missiles--;	    
				Mix_PlayChannel(-1,chunk[1],0);
			    }else
				Mix_PlayChannel(-1,chunk[2],0);
			}
			ship.tols = t2;
		    }
		}

	    if(keys[SDLK_RIGHT]|| dpad == SDL_HAT_RIGHT || joyx > 3200 ) { //move right
		if(ship.energy != 0)
		    ship.rect.x=ship.rect.x+((int)(ship.velocity*dt));
		if(ship.rect.x>screen->w - ship.image->w)
		    ship.rect.x=screen->w - ship.image->w;
	    }	   

	    if(keys[SDLK_LEFT]|| dpad == SDL_HAT_LEFT || joyx < -3200 ) { //move left
		if(ship.energy != 0)
		    ship.rect.x=ship.rect.x-((int)(ship.velocity*dt));
		if(ship.rect.x<0)
		    ship.rect.x=0;
	    }	     

	    if(keys[SDLK_UP] || dpad == SDL_HAT_UP || joyy < -3200) { //move up
		if(ship.energy != 0)
		    ship.rect.y=ship.rect.y-((int)(ship.velocity*dt));
		if(ship.rect.y<0)
		    ship.rect.y=0;
	    }

	    if(keys[SDLK_DOWN] || dpad == SDL_HAT_DOWN || joyy > 3200) { //move down
		if(ship.energy != 0)
		    ship.rect.y=ship.rect.y+((int)(ship.velocity*dt));
		if(ship.rect.y>screen->h - ship.image->h)
		    ship.rect.y=screen->h - ship.image->h;
	    }
	} //!paused_game

	//muzyka: glosnosc+
	if(keys[SDLK_KP_PLUS] || ybutton) {
	    music_volume+=5;

	    if(music_volume > 128)
		music_volume = 128;

	    Mix_VolumeMusic(music_volume);
	}
	//muzyka: glosnosc-
	if(keys[SDLK_KP_MINUS] || xbutton)	{
	    music_volume-=5;
	    if(music_volume < 0)
		music_volume = 0;
	    Mix_VolumeMusic(music_volume);
	}	    
	//SFX: glosnosc+
	if(keys[SDLK_u]) {
	    chunk_volume+=5;

	    if(chunk_volume > 100)
		chunk_volume = 100;
	    Mix_Volume(-1,chunk_volume);
	}
	//SFX: glosnosc-
	if(keys[SDLK_l]) {
	    chunk_volume-=5;
	    if(chunk_volume < 0)
		chunk_volume = 0;
	    Mix_Volume(-1,chunk_volume);
	}
	//kontynuacja gry
	if(!ships || game_finished)
	    if(keys[SDLK_RETURN]||abutton) {
		ships=4;
		ship.energy = 100;
		ship.shield = 50;
		ship.rect.x = screen->w/2 - ship.image->w/2;
		ship.rect.y = screen->h - ship.image->h;
		cannon_ammo = 1200;
		missiles = 50;
		score = 0;
		is_boss = 0;
		current_level = 1;
		NewGame(); // start new game
	    }
	// wyjscie z gry
	if(keys[SDLK_ESCAPE] || keys[SDLK_q] || ltrigger&&rtrigger&&blackbutton) {
	    quit=1;
	}
	// dodanie wroga
	if(t2 - tol_add_ship > 800 && is_boss == 0 && !paused_game && !game_finished){
	    AddOBJ(0,0,ENEMY);
	    tol_add_ship = t2;
	}
	// dodanie paczki
	if(t2 - tol_add_pack > 3000 && !paused_game && !game_finished){ 
	    switch(rand_ab(5,8))
	    {
		case PACK_LIVE:
		    AddOBJ(0,0,PACK_LIVE); //add ship pack
		    break;
		case PACK_ENERGY:
		    AddOBJ(0,0,PACK_ENERGY); // add energy pack
		    break;
		case PACK_SHIELD:
		    AddOBJ(0,0,PACK_SHIELD); // add shield pack
		    break;
		case PACK_SURPRISE:
		    AddOBJ(0,0,PACK_SURPRISE); //add surprise pack
		    break;	    
	    }
	    tol_add_pack = t2;
	}

	// Przemieszczenie oraz narysowanie wszystkich obiektow
	for(i=0;i<size;i++)
	{
	    if(!paused_game)
	    {
		// Wrog strzela
		if(t2 - objects[i].tols > 350 && objects[i].type == ENEMY && is_boss == 0 && !game_finished){
		    switch(rand_ab(0,10))
		    {
			case 5:
			case 2:
			case 7:
			    // dodanie rakiety
			    AddOBJ(objects[i].rect.x + objects[i].image->w/2-1,objects[i].rect.y + objects[i].image->h,MISSILE);
			    break;
			default:
			    // dodanie pocisku
			    AddOBJ(objects[i].rect.x + objects[i].image->w/2-1,objects[i].rect.y + objects[i].image->h,BULLET);
			    break;
		    }
		    objects[i].tols = t2;
		}else
		    // Boss strzela
		    if(t2 - objects[i].tols > 100 && objects[i].type == BOSS && !game_finished){
			switch(rand_ab(0,10))
			{
			    case 5:
			    case 2:
			    case 7:
			    case 9:
				// dodanie pocisku
				AddOBJ(objects[i].rect.x + objects[i].image->w/2-1,objects[i].rect.y + objects[i].image->h,BULLET);
				break;
			    default:
				// dodanie rakiety
				AddOBJ(objects[i].rect.x + objects[i].image->w/2-1,objects[i].rect.y + objects[i].image->h,MISSILE);
				break;
			}
			objects[i].tols = t2;
		    }
		objects[i].MoveOBJ(&objects[i]); // move object
		CheckScreenEdges(i); // check screen edges
		CheckEnemyCollisions(i); // check enemy collisions
	    }
	    DrawOBJ(objects[i]); // draw objects
	}

	if(!paused_game)
	    CheckShipCollisions(); // check player collisions
	if(ship.energy != 0)
	    DrawOBJ(ship); // draw player ship

	DrawExplosions(); // draw all explosions
	Show_HUD(); //Show HUD	


	// delete all dead objects
	for(i=0; i<size; i++)
	{
	    if(!objects[i].energy) {

		if(objects[i].type == ENEMY || objects[i].type == BOSS){
		    //add explosion in enemy position
		    AddExplosion(objects[i].rect.x + objects[i].image->w/2, objects[i].rect.y + objects[i].image->h/2);
		}

		DeleteOBJ(i); //delete object
		i--;
	    }
	}
	// usuwa wszystkie przeznaczone do tego obiekty
	for(i=0; i<size; i++)
	{
	    if(objects[i].remove) {
		DeleteOBJ(i); // delete object
		i--;
	    }
	}
	
	//D3D_Device->SetFlickerFilter(1);
	//wtf this should be working !!!! >:-(
	SDL_Flip(screen); //flip screen
	

	if(paused_game)
	    SDL_Delay(25);
	num_frames++;
	if(num_frames == 50)
	{
	    fps = 50.0f / ( ((float)SDL_GetTicks())/1000.0f-fps_time );
	    fps_time = ((float)SDL_GetTicks())/1000.0f;
	    num_frames = 0;
	}
    } // while(!quit)

    if(Mix_PlayingMusic() == 1 && paused_music == 0){
	Mix_FadeOutMusic(500); // fade out music
    }

    SDL_Delay(600);

    for(i=0;i<NUM_TRACKS;i++) //free all tracks
	Mix_FreeMusic(music[i]); 

    for(i=0;i<NUM_CHUNKS;i++) // chunks
	Mix_FreeChunk(chunk[i]);

    for(i=0;i<NUM_BOOM_FRAMES;i++) //explosion frames
	SDL_FreeSurface(frame[i]);

    for(i=0;i<NUM_IMAGES;i++) // images
	SDL_FreeSurface(obj[i]);

    FreeFont(font); //free font

    Mix_CloseAudio(); //close audio
    SDL_Quit(); //quit SDL
    printf("%sGAME OVER!%s Your score: %s%d%s\n",red[0], red[1], green[0], score, green[1]);
    printf("You played %s%ld%s seconds \n",green[0], time(NULL)-game_time, green[1]);    
    write_log("Closing session with no error\n");

	
	XLaunchNewImage( "D:\\default.xbe", (LAUNCH_DATA*)&LaunchData );

    return 0;
}


void load_settings(void)
{


//Open the config file.
conf=fopen("D:\\config.cfg", "r");
fread(&xpos, sizeof(int), 1,conf);
fread(&ypos, sizeof(int), 1, conf);
fread(&xstretch, sizeof(int), 1, conf);
fread(&ystretch, sizeof(int), 1, conf);
fread(&flickerlevel, sizeof(int), 1, conf);
fclose(conf);

//now do the stuff
//D3D_Device->SetFlickerFilter(flickerlevel);
//now resize our screen
SDL_XBOX_SetScreenPosition(xpos,ypos);
SDL_XBOX_SetScreenStretch(xstretch,ystretch);
}



